/***************************************************************************
                          knd_pcap.h  -  description                              
                             -------------------                                         
    begin                : Thu Mar 25 14:26:46 GMT 1999
                                           
    copyright            : (C) 1999 by Mike Richardson                         
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef		KND_PCAP_H 
#define		KND_PCAP_H 

#include	<stdio.h>
#include	<sys/time.h>
#include	<unistd.h>

#include	<qobject.h>

#include	<ksock.h>

#include	"defines.h"
#include	"classes.h"

typedef	struct	timeval	TVAL	;

/*  PCapInf								*/
/*  Structure used to pass packet capture information about between	*/
/*  objects								*/

struct	PCapInf
{	int	ltype	;		/* Datalink type		*/
	int	snapl	;		/* Capture snap length		*/
	ULONG	nmask	;		/* Nextwork mask		*/
}	;


/*  KNDPCap	: Ksnuffle packet capture				*/
/*  Instance of this class handle a particular capture configuration.	*/
/*  There is one instance for each monitor created by the user.		*/

class	KNDPCap : public QObject
{
	Q_OBJECT

protected :

	KNDView	*view	;		/* Associated view object	*/
	char	*iface	;		/* Interface name		*/

public	:
	KNDPCap 	 	 (KNDView *) ;
	virtual	~KNDPCap 	 () ;

	virtual	void	setProg	 (CCHAR *, TrigInf *, EventInf *, int) = 0 ;
	virtual	void	execute	 (bool, FILE * = NULL, bool = false) = 0 ;
	virtual	void	timerTick(long) = 0 ;

	virtual	PCapInf	*getInfo   () = 0 ;
	virtual	void	clickQuery () = 0 ;

protected :

	void	clear	   () ;

	bool	execing	;		/* Monitor is executing		*/
}	;


#endif	// KND_PCAP_H 
