#ifndef		_NETHDRS_H
#define		_NETHDRS_H

#define		__FAVOR_BSD

#include	<net/if.h>
#include	<netinet/in_systm.h>
#include	<netinet/ip.h>
#include	<netinet/if_ether.h>
#include	<netinet/tcp.h>
#include	<netinet/udp.h>
#include	<netinet/ip_icmp.h>
#include	<netdb.h>


/*  TCP/IP decoding (with due acknowledgement to the tcpdump(8)		*/
/*  authors) attempts to identifify ACK and SEQ offsets in TCP/IP	*/
/*  streams. A hash table (hashed on ordered source/destination		*/
/*  addresses) holds that latest ACK and SEQ values for each stream.	*/
/*  The hash table size is straight from the tcpdump(8) code.		*/

struct	TCPADDR
{	ulong	src	;	/* Source address			*/
	ulong	dst	;	/* Destination address			*/
	ulong	portp	;	/* Source and destination ports		*/
}	;

struct	TCPHASH
{	TCPHASH	*next	;	/* Next on hash queue			*/
	TCPADDR	tcpaddr	;	/* TCP/IP addresses for entry		*/
	ulong	seq	;	/* Last sequence			*/
	ulong	ack	;	/* Last ack				*/
}	;

#endif		/* _NETHDRS_H */
